// MemDebug.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#include "MemDebugStats.h"

#include <stdLib.h>

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    {
        // Second, we grab a MemDebugSnapshot instance.
        // This will hold the current state of the heap,
        // at the time GetMemSnapshot() is called.
        // It's surprisingly very cheap in CPU and memory.
        MemDebugSnapshot snapshot;
        GetMemSnapshot(snapshot);

        // Now, we allocate a bunch of crap.
        int i;
        for (i = 0; i < 1000; ++i) {
            DBG_NEW char[rand() & 0xFFF];   // Large
            DBG_NEW char[rand() & 0x0FF];   // Small
        }

        // And this dumps out the heap memory statistics
        // of all allocations that happened since the
        // snapshot was taken.
        DUMP_MEM_STATS(snapshot);
    }

    {
        // Again, we grab a new MemDebugSnapshot instance.
        MemDebugSnapshot snapshot;
        GetMemSnapshot(snapshot);

        // Now, we allocate just a few bytes.
        DBG_NEW int[7]; // 28 bytes

        // And again, this dumps out the heap memory
        // statistics of all allocations that happened
        // since the new snapshot was taken.
        DUMP_MEM_STATS(snapshot);
    }

    // Finally, this dumps all the memory ever allocated.
    // So, it includes the allocations made above,
    // and anything else that might happen behind our backs.
    DUMP_CURRENT_MEM_STATS();

	return 0;
}
